#!/usr/bin/perl

use strict;
use warnings;
use File::Spec;

my @res = qw/convert interlace merge shadeboost tfx/;
my $path = File::Spec->catdir("plugins", "GSdx", "res");

foreach my $r (@res) {
    glsl2h($path, $r, "glsl");
}
glsl2h($path, "fxaa", "fx");

sub glsl2h {
    my $path = shift;
    my $glsl = shift;
    my $ext  = shift;

    my $in = File::Spec->catfile($path, "${glsl}.$ext");
    my $out = File::Spec->catfile($path, "${glsl}.h");
    open(my $GLSL, "<$in") or die;
    open(my $H, ">$out") or die;

    my $header = <<EOS;
/*
 *	Copyright (C) 2011-2013 Gregory hainaut
 *	Copyright (C) 2007-2009 Gabest
 *
 *  This file was generated by glsl2h.pl script
 *
 *  This Program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2, or (at your option)
 *  any later version.
 *
 *  This Program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with GNU Make; see the file COPYING.  If not, write to
 *  the Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA USA.
 *  http://www.gnu.org/copyleft/gpl.html
 *
 */

#pragma once

#include "stdafx.h"

static const char* ${glsl}_${ext} =
EOS

    print $H $header;

    my $line;
    while(defined($line = <$GLSL>)) {
        chomp $line;
        $line =~ s/"/\\"/g;
        print $H "\t\"$line\\n\"\n";
    }
    print $H "\t;\n";
}
